diff --git a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/v25_30/SchemaUpdater_25_30.java b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/v25_30/SchemaUpdater_25_30.java
index 78ffad1bbf..d1605ee2d8 100644
--- a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/v25_30/SchemaUpdater_25_30.java
+++ b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/v25_30/SchemaUpdater_25_30.java
@@ -27,7 +27,7 @@ import eu.etaxonomy.cdm.database.update.TableCreator;
 import eu.etaxonomy.cdm.database.update.TableDroper;
 import eu.etaxonomy.cdm.database.update.TableNameChanger;
 import eu.etaxonomy.cdm.database.update.v24_25.SchemaUpdater_24_25;
-import eu.etaxonomy.cdm.database.update.v30_31.SchemaUpdater_301_31;
+import eu.etaxonomy.cdm.database.update.v30_31.SchemaUpdater_30_301;
 
 
 /**
@@ -151,7 +151,7 @@ public class SchemaUpdater_25_30 extends SchemaUpdaterBase {
 		stepList.add(exsiccatumAdder);
 		
 		//add primary collector
-		stepName = "Add primary collector to field observation";
+		stepName = "Add primary collector to field unit";
 		ColumnAdder primaryCollectorAdder = ColumnAdder.NewIntegerInstance(stepName, "SpecimenOrObservationBase", "primaryCollector_id", INCLUDE_AUDIT, false, "AgentBase");
 		stepList.add(primaryCollectorAdder);
 
@@ -315,7 +315,7 @@ public class SchemaUpdater_25_30 extends SchemaUpdaterBase {
 	 */
 	@Override
 	public ISchemaUpdater getNextUpdater() {
-		return SchemaUpdater_301_31.NewInstance();
+		return SchemaUpdater_30_301.NewInstance();
 	}
 
 	/* (non-Javadoc)
diff --git a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/v25_30/SequenceTableCreator.java b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/v25_30/SequenceTableCreator.java
index 8ee46d1249..98a786b452 100644
--- a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/v25_30/SequenceTableCreator.java
+++ b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/v25_30/SequenceTableCreator.java
@@ -34,7 +34,6 @@ import eu.etaxonomy.cdm.database.update.SchemaUpdaterStepBase;
  * 
  * @author n.hoffmann
  * @created Oct 27, 2010
- * @version 1.0
  */
 public class SequenceTableCreator extends SchemaUpdaterStepBase {
 
@@ -58,17 +57,14 @@ public class SequenceTableCreator extends SchemaUpdaterStepBase {
 	public static SequenceTableCreator NewInstance(String stepName){
 		return new SequenceTableCreator(stepName);
 	}
-	
-	/* (non-Javadoc)
-	 * @see eu.etaxonomy.cdm.database.update.SchemaUpdaterStepBase#invoke(eu.etaxonomy.cdm.database.ICdmDataSource, eu.etaxonomy.cdm.common.IProgressMonitor)
-	 */
+
 	@Override
 	public Integer invoke(ICdmDataSource datasource, IProgressMonitor monitor){
 		boolean result = true;
 		try {
-			createSequenceTable(datasource, monitor);
-			makeEntriesForEntityTables(datasource, monitor);
-		} catch (SQLException e) {
+			result &= createSequenceTable(datasource, monitor);
+			result &= makeEntriesForEntityTables(datasource, monitor);
+		} catch (Exception e) {
 			monitor.warning(e.getMessage(), e);
 			result = false;
 		}
@@ -107,7 +103,7 @@ public class SequenceTableCreator extends SchemaUpdaterStepBase {
 	 * @return
 	 * @throws SQLException 
 	 */
-	private void makeEntriesForEntityTables(ICdmDataSource datasource, IProgressMonitor monitor) throws SQLException {
+	private boolean makeEntriesForEntityTables(ICdmDataSource datasource, IProgressMonitor monitor) throws SQLException {
 		
 		DatabaseMetaData metaData = datasource.getMetaData();
 		ResultSet resultSet = metaData.getTables(datasource.getDatabase(), null, null, null);
@@ -147,7 +143,9 @@ public class SequenceTableCreator extends SchemaUpdaterStepBase {
 				
 				datasource.executeUpdate(query);
 			}
+			
 		}
+		return true;
 	}
 
 }
diff --git a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/v25_30/TermUpdater_25_30.java b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/v25_30/TermUpdater_25_30.java
index 07077bdbad..b4db6b11f3 100644
--- a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/v25_30/TermUpdater_25_30.java
+++ b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/v25_30/TermUpdater_25_30.java
@@ -22,8 +22,9 @@ import eu.etaxonomy.cdm.database.update.TermUpdaterBase;
 import eu.etaxonomy.cdm.database.update.VocabularyCreator;
 import eu.etaxonomy.cdm.database.update.v24_25.TermUpdater_24_25;
 import eu.etaxonomy.cdm.database.update.v30_31.TermUpdater_30_31;
+import eu.etaxonomy.cdm.model.common.DefinedTerm;
 import eu.etaxonomy.cdm.model.common.Language;
-import eu.etaxonomy.cdm.model.occurrence.DeterminationModifier;
+import eu.etaxonomy.cdm.model.common.TermType;
 
 /**
  * @author a.mueller
@@ -59,24 +60,24 @@ public class TermUpdater_25_30 extends TermUpdaterBase implements ITermUpdater {
 		List<ITermUpdaterStep> list = new ArrayList<ITermUpdaterStep>();
 
 		// cf.
-		UUID uuidTerm = DeterminationModifier.uuidConfer;
+		UUID uuidTerm = DefinedTerm.uuidConfer;
 		String description = "Confer";
 		String label = "confer";
 		String abbrev = "cf.";
-		String dtype = DeterminationModifier.class.getSimpleName();
+		String dtype = DefinedTerm.class.getSimpleName();
 		UUID uuidVocabulary = UUID.fromString("fe87ea8d-6e0a-4e5d-b0da-0ab8ea67ca77");
 		UUID uuidAfterTerm = null ; //UUID.fromString("");
 		list.add( SingleTermUpdater.NewInstance("Add 'confer (cf.)' determination modifier", uuidTerm, description, label, abbrev, dtype, uuidVocabulary, Language.uuidLatin, true, uuidAfterTerm));
 
 		
 		// aff.
-		uuidTerm = DeterminationModifier.uuidAffinis;
+		uuidTerm = DefinedTerm.uuidAffinis;
 		description = "Affinis";
 		label = "affinis";
 		abbrev = "aff.";
-		dtype = DeterminationModifier.class.getSimpleName();
+		dtype = DefinedTerm.class.getSimpleName();
 		uuidVocabulary = UUID.fromString("fe87ea8d-6e0a-4e5d-b0da-0ab8ea67ca77");
-		uuidAfterTerm = DeterminationModifier.uuidConfer;
+		uuidAfterTerm = DefinedTerm.uuidConfer;
 		list.add( SingleTermUpdater.NewInstance("Add 'affinis (aff.)' determination modifier", uuidTerm, description, label, abbrev, dtype, uuidVocabulary, Language.uuidLatin, true, uuidAfterTerm));
 
 		
@@ -87,7 +88,7 @@ public class TermUpdater_25_30 extends TermUpdaterBase implements ITermUpdater {
 		abbrev = "undef. lang.";
 		boolean isOrdered = false;
 		Class termClass = Language.class;
-		VocabularyCreator updater = VocabularyCreator.NewVocabularyInstance(uuidUndefLanguagesVoc, description, label, abbrev, isOrdered, termClass);
+		VocabularyCreator updater = VocabularyCreator.NewVocabularyInstance(uuidUndefLanguagesVoc, description, label, abbrev, isOrdered, termClass, TermType.Language);
 		list.add(updater);
 		
 		// unknown language
diff --git a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/v30_31/LanguageLabelUpdater.java b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/v30_31/LanguageLabelUpdater.java
index 980ce3129c..762118d764 100644
--- a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/v30_31/LanguageLabelUpdater.java
+++ b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/v30_31/LanguageLabelUpdater.java
@@ -22,7 +22,7 @@ import eu.etaxonomy.cdm.database.update.SchemaUpdaterStepBase;
  * @author a.mueller
  * @date 15.12.2010
  */
-public class LanguageLabelUpdater extends SchemaUpdaterStepBase implements ITermUpdaterStep{
+public class LanguageLabelUpdater extends SchemaUpdaterStepBase<LanguageLabelUpdater> implements ITermUpdaterStep{
 	@SuppressWarnings("unused")
 	private static final Logger logger = Logger.getLogger(LanguageLabelUpdater.class);
 
@@ -39,36 +39,42 @@ public class LanguageLabelUpdater extends SchemaUpdaterStepBase implements ITerm
 	}
 
 	@Override
-	public Integer invoke(ICdmDataSource datasource, IProgressMonitor monitor) throws SQLException {
+	public Integer invoke(ICdmDataSource datasource, IProgressMonitor monitor)  {
 		
-		//update representation label
-		String sql;
-		sql = " UPDATE Representation " + 
-			" SET label = text " +
-			" WHERE id IN ( SELECT MN.representations_id " +
-				" FROM DefinedTermBase lang " +
-				" INNER JOIN DefinedTermBase_Representation MN ON lang.id = MN.DefinedTermBase_id " +
-				" WHERE lang.DTYPE = 'Language' " +
-				" )";
-		datasource.executeUpdate(sql);
-		
-		//update term titleCache
-		sql = " UPDATE DefinedTermBase dtb " + 
-			  " SET titleCache = " +  
-					" ( " +
-					" SELECT rep.label  " +
-					" FROM DefinedTermBase_Representation MN " + 
-					" INNER JOIN Representation rep ON MN.representations_id = rep.id " +
-					" WHERE dtb.id = MN.DefinedTermBase_id AND rep.language_id = @langId) " + 
-				" WHERE dtb.DTYPE = 'Language'";
-		String englishId = String.valueOf(getEnglishLanguageId(datasource, monitor));
-		if (englishId == null){
-			throw new NullPointerException("English id could not be found");
+		try {
+			//update representation label
+			String sql;
+			sql = " UPDATE Representation " + 
+				" SET label = text " +
+				" WHERE id IN ( SELECT MN.representations_id " +
+					" FROM DefinedTermBase lang " +
+					" INNER JOIN DefinedTermBase_Representation MN ON lang.id = MN.DefinedTermBase_id " +
+					" WHERE lang.DTYPE = 'Language' " +
+					" )";
+			datasource.executeUpdate(sql);
+			
+			//update term titleCache
+			sql = " UPDATE DefinedTermBase dtb " + 
+				  " SET titleCache = " +  
+						" ( " +
+						" SELECT rep.label  " +
+						" FROM DefinedTermBase_Representation MN " + 
+						" INNER JOIN Representation rep ON MN.representations_id = rep.id " +
+						" WHERE dtb.id = MN.DefinedTermBase_id AND rep.language_id = @langId) " + 
+					" WHERE dtb.DTYPE = 'Language'";
+			String englishId = String.valueOf(getEnglishLanguageId(datasource, monitor));
+			if (englishId == null){
+				throw new NullPointerException("English id could not be found");
+			}
+			sql = sql.replace("@langId", englishId);
+			datasource.executeUpdate(sql);
+			
+			return 0;
+		} catch (Exception e) {
+			monitor.warning(e.getMessage(), e);
+			logger.warn(e.getMessage());
+			return null;
 		}
-		sql = sql.replace("@langId", englishId);
-		datasource.executeUpdate(sql);
-		
-		return 0;
 	}
 
 	
diff --git a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/v30_31/SchemaUpdater_30_301.java b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/v30_31/SchemaUpdater_30_301.java
index 3730188922..0368f3084a 100644
--- a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/v30_31/SchemaUpdater_30_301.java
+++ b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/v30_31/SchemaUpdater_30_301.java
@@ -22,6 +22,7 @@ import eu.etaxonomy.cdm.database.update.SchemaUpdaterBase;
 import eu.etaxonomy.cdm.database.update.TableDroper;
 import eu.etaxonomy.cdm.database.update.UniqueIndexDropper;
 import eu.etaxonomy.cdm.database.update.v25_30.SchemaUpdater_25_30;
+import eu.etaxonomy.cdm.database.update.v31_33.SchemaUpdater_31_33;
 
 
 /**
@@ -89,7 +90,7 @@ public class SchemaUpdater_30_301 extends SchemaUpdaterBase {
 	 */
 	@Override
 	public ISchemaUpdater getNextUpdater() {
-		return SchemaUpdater_301_31.NewInstance();
+		return SchemaUpdater_31_33.NewInstance();
 	}
 
 	/* (non-Javadoc)
diff --git a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/v30_31/TermUpdater_311_312.java b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/v30_31/TermUpdater_311_312.java
index 6596bfa33e..4c709fa66a 100644
--- a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/v30_31/TermUpdater_311_312.java
+++ b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/v30_31/TermUpdater_311_312.java
@@ -17,11 +17,9 @@ import org.apache.log4j.Logger;
 
 import eu.etaxonomy.cdm.database.update.ITermUpdater;
 import eu.etaxonomy.cdm.database.update.ITermUpdaterStep;
-import eu.etaxonomy.cdm.database.update.SimpleSchemaUpdaterStep;
 import eu.etaxonomy.cdm.database.update.SingleTermUpdater;
 import eu.etaxonomy.cdm.database.update.TermUpdaterBase;
 import eu.etaxonomy.cdm.model.common.Language;
-import eu.etaxonomy.cdm.model.description.Sex;
 import eu.etaxonomy.cdm.model.name.HybridRelationshipType;
 
 /**
@@ -72,7 +70,7 @@ public class TermUpdater_311_312 extends TermUpdaterBase implements ITermUpdater
 		description = "hermaphrodite";
 		label = "hermaphrodite";
 		abbrev = "h";
-		dtype = Sex.class.getSimpleName();
+		dtype = "Sex";
 		isOrdered = true;
 		uuidVocabulary = UUID.fromString("9718b7dd-8bc0-4cad-be57-3c54d4d432fe");
 		uuidAfterTerm = UUID.fromString("b4cfe0cb-b35c-4f97-9b6b-2b3c096ea2c0");
@@ -84,8 +82,8 @@ public class TermUpdater_311_312 extends TermUpdaterBase implements ITermUpdater
 		uuidTerm = UUID.fromString("4f5e4c51-a664-48ad-8238-2e9f49eaf8dd");
 		description = "Sex unknown";
 		label = "unknown";
-		abbrev = "s.u.";
-		dtype = Sex.class.getSimpleName();
+		abbrev = "sex ?";
+		dtype = "Sex";
 		isOrdered = true;
 		uuidVocabulary = UUID.fromString("9718b7dd-8bc0-4cad-be57-3c54d4d432fe");
 		uuidAfterTerm = UUID.fromString("0deddc65-2505-4c77-91a7-17d0de24afcc");
diff --git a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/v30_31/TermUpdater_314_315.java b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/v30_31/TermUpdater_314_315.java
index 8784d06564..25fdc37833 100644
--- a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/v30_31/TermUpdater_314_315.java
+++ b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/v30_31/TermUpdater_314_315.java
@@ -19,6 +19,7 @@ import eu.etaxonomy.cdm.database.update.ITermUpdater;
 import eu.etaxonomy.cdm.database.update.ITermUpdaterStep;
 import eu.etaxonomy.cdm.database.update.TermRepresentationUpdater;
 import eu.etaxonomy.cdm.database.update.TermUpdaterBase;
+import eu.etaxonomy.cdm.database.update.v31_33.TermUpdater_31_33;
 import eu.etaxonomy.cdm.model.common.Language;
 
 /**
@@ -274,7 +275,7 @@ public class TermUpdater_314_315 extends TermUpdaterBase implements ITermUpdater
 	 */
 	@Override
 	public ITermUpdater getNextUpdater() {
-		return null;
+		return TermUpdater_31_33.NewInstance();
 	}
 
 	/* (non-Javadoc)
diff --git a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/v31_33/RankClassUpdater.java b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/v31_33/RankClassUpdater.java
new file mode 100644
index 0000000000..5eabec88ee
--- /dev/null
+++ b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/v31_33/RankClassUpdater.java
@@ -0,0 +1,100 @@
+// $Id$
+/**
+* Copyright (C) 2009 EDIT
+* European Distributed Institute of Taxonomy 
+* http://www.e-taxonomy.eu
+* 
+* The contents of this file are subject to the Mozilla Public License Version 1.1
+* See LICENSE.TXT at the top of this package for the full license terms.
+*/
+package eu.etaxonomy.cdm.database.update.v31_33;
+
+import java.sql.SQLException;
+
+import org.apache.log4j.Logger;
+
+import eu.etaxonomy.cdm.common.monitor.IProgressMonitor;
+import eu.etaxonomy.cdm.database.ICdmDataSource;
+import eu.etaxonomy.cdm.database.update.ITermUpdaterStep;
+import eu.etaxonomy.cdm.database.update.SchemaUpdaterStepBase;
+import eu.etaxonomy.cdm.model.name.Rank;
+import eu.etaxonomy.cdm.model.name.RankClass;
+
+/**
+ * @author a.mueller
+ * @date 15.12.2013
+ */
+public class RankClassUpdater extends SchemaUpdaterStepBase<RankClassUpdater> implements ITermUpdaterStep{
+	private static final Logger logger = Logger.getLogger(RankClassUpdater.class);
+
+	private static final String stepName = "Update rank class values";
+	
+// **************************** STATIC METHODS ********************************/
+
+	public static final RankClassUpdater NewInstance(){
+		return new RankClassUpdater(stepName);	
+	}
+
+	protected RankClassUpdater(String stepName) {
+		super(stepName);
+	}
+
+	@Override
+	public Integer invoke(ICdmDataSource datasource, IProgressMonitor monitor) throws SQLException {
+		
+		try {
+			//update representation label
+			String sql;
+			sql = " SELECT orderindex FROM DefinedTermBase WHERE uuid = '%s'";
+			Integer genusOrderIndex = (Integer)datasource.getSingleValue(String.format(sql, Rank.uuidGenus));
+			Integer infraGenericOrderIndex = (Integer)datasource.getSingleValue(String.format(sql, Rank.uuidInfragenericTaxon));
+			Integer speciesOrderIndex = (Integer)datasource.getSingleValue(String.format(sql, Rank.uuidSpecies));
+			
+			//suprageneric
+			sql = " UPDATE DefinedTermBase dtb " + 
+					" SET dtb.rankClass = '%s' " + 
+					" WHERE dtb.DTYPE = 'Rank' AND dtb.orderindex < %d";
+			datasource.executeUpdate(String.format(sql, RankClass.Suprageneric.getKey(), genusOrderIndex));
+
+			
+			//genus
+			sql = " UPDATE DefinedTermBase dtb " + 
+					" SET dtb.rankClass = '%s' " + 
+					" WHERE dtb.DTYPE = 'Rank' AND dtb.orderindex = %d";
+			datasource.executeUpdate(String.format(sql, RankClass.Genus.getKey(), genusOrderIndex));
+			
+			//infrageneric
+			sql = " UPDATE DefinedTermBase dtb " + 
+					" SET dtb.rankClass = '%s' " + 
+					" WHERE dtb.DTYPE = 'Rank' AND dtb.orderindex > %d AND dtb.orderindex <= %d";
+			datasource.executeUpdate(String.format(sql, RankClass.Infrageneric.getKey(), genusOrderIndex, infraGenericOrderIndex));
+
+			//species group
+			sql = " UPDATE DefinedTermBase dtb " + 
+					" SET dtb.rankClass = '%s' " + 
+					" WHERE dtb.DTYPE = 'Rank' AND dtb.orderindex > %d AND dtb.orderindex < %d";
+			datasource.executeUpdate(String.format(sql, RankClass.SpeciesGroup.getKey(), infraGenericOrderIndex, speciesOrderIndex));
+			
+			//species
+			sql = " UPDATE DefinedTermBase dtb " + 
+					" SET dtb.rankClass = '%s' " + 
+					" WHERE dtb.DTYPE = 'Rank' AND dtb.orderindex = %d";
+			datasource.executeUpdate(String.format(sql, RankClass.Species.getKey(), speciesOrderIndex));
+
+			//infraspecific
+			sql = " UPDATE DefinedTermBase dtb " + 
+					" SET dtb.rankClass = '%s' " + 
+					" WHERE dtb.DTYPE = 'Rank' AND dtb.orderindex > %d";
+			datasource.executeUpdate(String.format(sql, RankClass.Infraspecific.getKey(), speciesOrderIndex));
+
+			
+			return 0;
+		} catch (Exception e) {
+			monitor.warning(e.getMessage(), e);
+			logger.warn(e.getMessage());
+			return null;
+		}
+	}
+
+	
+}
diff --git a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/v31_33/SpecimenMediaMoverUpdater.java b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/v31_33/SpecimenMediaMoverUpdater.java
new file mode 100644
index 0000000000..f248904d4f
--- /dev/null
+++ b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/v31_33/SpecimenMediaMoverUpdater.java
@@ -0,0 +1,138 @@
+// $Id$
+/**
+* Copyright (C) 2009 EDIT
+* European Distributed Institute of Taxonomy 
+* http://www.e-taxonomy.eu
+* 
+* The contents of this file are subject to the Mozilla Public License Version 1.1
+* See LICENSE.TXT at the top of this package for the full license terms.
+*/
+package eu.etaxonomy.cdm.database.update.v31_33;
+
+import java.sql.ResultSet;
+import java.sql.SQLException;
+import java.util.UUID;
+
+import org.apache.log4j.Logger;
+
+import eu.etaxonomy.cdm.common.monitor.IProgressMonitor;
+import eu.etaxonomy.cdm.database.ICdmDataSource;
+import eu.etaxonomy.cdm.database.update.ITermUpdaterStep;
+import eu.etaxonomy.cdm.database.update.SchemaUpdaterStepBase;
+
+/**
+ * @author a.mueller
+ * @date 15.12.2013
+ */
+public class SpecimenMediaMoverUpdater extends SchemaUpdaterStepBase<SpecimenMediaMoverUpdater> implements ITermUpdaterStep{
+	private static final Logger logger = Logger.getLogger(SpecimenMediaMoverUpdater.class);
+
+	private static final String stepName = "Update rank class values";
+	
+// **************************** STATIC METHODS ********************************/
+
+	public static final SpecimenMediaMoverUpdater NewInstance(){
+		return new SpecimenMediaMoverUpdater(stepName);	
+	}
+
+	protected SpecimenMediaMoverUpdater(String stepName) {
+		super(stepName);
+	}
+
+	@Override
+	public Integer invoke(ICdmDataSource datasource, IProgressMonitor monitor) throws SQLException {
+		
+		try {
+			Integer featureId = null;
+			
+			//get existing media
+			String sql = " SELECT SpecimenOrObservationBase_id,  media_id FROM SpecimenOrObservationBase_Media";
+			ResultSet rs = datasource.executeQuery(sql); 
+			while (rs.next()){
+				if (featureId == null){
+					featureId = getFeatureId(datasource);
+				}
+				
+				Integer specimenId = rs.getInt("SpecimenOrObservationBase_id");
+				Integer mediaId = rs.getInt("media_id");
+				
+				//image gallery
+				Number galleryId = getOrCreateImageGallery(datasource, monitor, specimenId);
+				
+				//textData
+				Number textDataId = getOrCreateTextData(datasource, monitor, galleryId, featureId);
+				
+				//sortIndex
+				Number sortIndex = getSortIndex(datasource, monitor, textDataId, mediaId);
+				
+				//insert
+				sql = "	INSERT INTO DescriptionElementBase_Media (DescriptionElementBase_id, media_id, sortIndex) " +
+						" VALUES (%d, %d, %d)";
+				sql = String.format(sql, textDataId, mediaId, sortIndex);
+				datasource.executeUpdate(sql);
+			}
+			
+			return 0;
+		} catch (Exception e) {
+			monitor.warning(e.getMessage(), e);
+			logger.warn(e.getMessage());
+			return null;
+		}
+	}
+
+	private Integer getFeatureId(ICdmDataSource datasource) throws SQLException {
+		String sql = " SELECT id FROM DefinedTermBase WHERE uuid = '84193b2c-327f-4cce-90ef-c8da18fd5bb5'";
+		return (Integer)datasource.getSingleValue(sql);
+	}
+
+	private Number getSortIndex(ICdmDataSource datasource, IProgressMonitor monitor, Number textDataId, Integer mediaId) throws SQLException {
+		String sql = " SELECT max(sortIndex) " +
+				" FROM DescriptionElementBase_Media MN " +
+				" WHERE MN.DescriptionElementBase_id = "+textDataId+" AND MN.media_id = " + mediaId;
+		Number sortIndex = (Long)datasource.getSingleValue(sql);
+		if (sortIndex == null){
+			sortIndex = 0;
+		}
+
+		return sortIndex;
+	}
+
+	private Number getOrCreateTextData(ICdmDataSource datasource, IProgressMonitor monitor, Number galleryId, Integer featureId) throws SQLException {
+	
+		String sql = " SELECT deb.id " + 
+				" FROM DescriptionElementBase deb " +
+				" WHERE deb.DTYPE = 'TextData' AND feature_id = "+ featureId +" AND deb.indescription_id = " + galleryId;
+		Number textDataId = (Integer)datasource.getSingleValue(sql);
+		
+		if (textDataId == null){
+			sql = " SELECT max(id)+1 FROM DescriptionElementBase ";
+			textDataId = (Long)datasource.getSingleValue(sql);
+			
+			sql = " INSERT INTO DescriptionElementBase (DTYPE, id, created, uuid, feature_id, indescription_id)  " +
+					" VALUES  ('TextData', %d, '%s', '%s', %d, %d) ";
+			sql = String.format(sql, textDataId, this.getNowString(), UUID.randomUUID().toString(), featureId, galleryId);
+			datasource.executeUpdate(sql);
+		}
+		return textDataId;
+
+	}
+
+	private Number getOrCreateImageGallery(ICdmDataSource datasource, IProgressMonitor monitor, Integer specimenId) throws SQLException {
+		String sql = " SELECT  db.id " + 
+				" FROM DescriptionBase db " +
+				" WHERE db.imagegallery = True AND db.specimen_id = " + specimenId;
+		Number descriptionId = (Number)datasource.getSingleValue(sql);
+		
+		if (descriptionId == null){
+			sql = " SELECT max(id)+1 FROM DescriptionBase ";
+			descriptionId = (Long)datasource.getSingleValue(sql);
+			sql = " INSERT INTO DescriptionBase (DTYPE, id, created, uuid, protectedtitlecache, titleCache, imagegallery, specimen_id) " +
+					" VALUES ('SpecimenDescription',  %d, '%s', '%s', 1, 'Specimenimage(s) moved for schema update', 1, %d) ";
+			sql = String.format(sql, descriptionId, this.getNowString(), UUID.randomUUID().toString(), specimenId);
+			datasource.executeUpdate(sql);
+		}
+		return descriptionId;
+	}
+
+	
+}
